All Classes Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
QoreBoolNode Class Reference

base class for Qore's 2 boolean classes: QoreBoolTrueNode and QoreBoolFalseNode More...

`#include <QoreBoolNode.h>`

Inheritance diagram for QoreBoolNode:
[legend]
Collaboration diagram for QoreBoolNode:
[legend]

## Public Member Functions

virtual DLLEXPORT QoreString * | getStringRepresentation (bool &del) const
| returns the value of the type converted to a string, default implementation: returns the empty string
virtual DLLEXPORT void | getStringRepresentation (QoreString &str) const
| concatentates the value of the type to an existing QoreString reference, default implementation does nothing
virtual DLLEXPORT DateTime * | getDateTimeRepresentation (bool &del) const
| returns the DateTime representation of this type (default implementation: returns ZeroDate, del = false)
virtual DLLEXPORT void | getDateTimeRepresentation (DateTime &dt) const
| assigns the date representation of a value to the DateTime reference passed, default implementation does nothing
virtual DLLEXPORT int | getAsString (QoreString &str, int foff, class ExceptionSink *xsink) const
| concatenate the verbose string representation of the value (including all contained values for container types) to an existing QoreString
virtual DLLEXPORT QoreString * | getAsString (bool &del, int foff, class ExceptionSink *xsink) const
| returns a QoreString giving the verbose string representation of the value (including all contained values for container types)
virtual DLLEXPORT bool | is_equal_soft (const AbstractQoreNode *v, ExceptionSink *xsink) const
| tests for equality ("deep compare" including all contained values for container types) with possible type conversion (soft compare)
virtual DLLEXPORT bool | is_equal_hard (const AbstractQoreNode *v, ExceptionSink *xsink) const
| tests for equality ("deep compare" including all contained values for container types) without type conversions (hard compare)
virtual DLLEXPORT const char * | getTypeName () const
| returns the type name as a c string
virtual DLLLOCAL AbstractQoreNode * | parseInit (LocalVar *oflag, int pflag, int &lvids, const QoreTypeInfo *&typeInfo)
| returns the type information
DLLLOCAL bool | getValue () const
| returns the boolean value of the object
Public Member Functions inherited from UniqueValueQoreNode
DLLLOCAL | UniqueValueQoreNode (qore_type_t t)
| constructor takes the type argument
DLLLOCAL | UniqueValueQoreNode (const UniqueValueQoreNode &)
| copy constructor
virtual DLLEXPORT AbstractQoreNode * | realCopy () const
| returns itself; objects of this type are not reference-counted and only deleted manually (by static destruction)
Public Member Functions inherited from SimpleValueQoreNode
DLLLOCAL | SimpleValueQoreNode (qore_type_t t, bool n_there_can_be_only_one=false)
| creates the object by assigning the type code and setting the "value" flag, unsetting the "needs_eval" flag, and setting "there_can_be_only_one"
Public Member Functions inherited from SimpleQoreNode
DLLLOCAL | SimpleQoreNode (qore_type_t t, bool n_value, bool n_needs_eval, bool n_there_can_be_only_one=false)
| constructor takes the type and value arguments
DLLLOCAL | SimpleQoreNode (const SimpleQoreNode &v)
| copy constructor
Public Member Functions inherited from AbstractQoreNode
DLLEXPORT | AbstractQoreNode (qore_type_t t, bool n_value, bool n_needs_eval, bool n_there_can_be_only_one=false, bool n_custom_reference_handlers=false)
| constructor takes the type
DLLEXPORT | AbstractQoreNode (const AbstractQoreNode &v)
| copy constructor
DLLEXPORT bool | getAsBool () const
| returns the boolean value of the object
DLLEXPORT int | getAsInt () const
| returns the integer value of the object
DLLEXPORT int64 | getAsBigInt () const
| returns the 64-bit integer value of the object
DLLEXPORT double | getAsFloat () const
| returns the float value of the object
DLLLOCAL bool | needs_eval () const
| returns true if the object needs evaluation to return a value, false if not
DLLLOCAL qore_type_t | getType () const
| returns the data type
DLLEXPORT AbstractQoreNode * | eval (ExceptionSink *xsink) const
| evaluates the object and returns a value (or 0)
DLLEXPORT AbstractQoreNode * | eval (bool &needs_deref, ExceptionSink *xsink) const
| optionally evaluates the argument
DLLEXPORT int64 | bigIntEval (ExceptionSink *xsink) const
| evaluates the object and returns a 64-bit integer value
DLLEXPORT int | integerEval (ExceptionSink *xsink) const
| evaluates the object and returns an integer value
DLLEXPORT bool | boolEval (ExceptionSink *xsink) const
| evaluates the object and returns a boolean value
DLLEXPORT double | floatEval (ExceptionSink *xsink) const
| evaluates the object and returns a floating-point value
DLLLOCAL bool | is_value () const
| returns true if the node represents a value
DLLEXPORT void | deref (ExceptionSink *xsink)
| decrements the reference count and calls derefImpl() if there_can_be_only_one is false, otherwise does nothing
DLLEXPORT AbstractQoreNode * | refSelf () const
| returns "this" with an incremented reference count
DLLEXPORT void | ref () const
| increments the reference count
DLLLOCAL bool | isReferenceCounted () const
| returns true if the object is reference-counted
Public Member Functions inherited from QoreReferenceCounter
DLLEXPORT | QoreReferenceCounter ()
| creates the reference counter object
DLLEXPORT | ~QoreReferenceCounter ()
| destroys the reference counter object
DLLLOCAL int | reference_count () const
| gets the reference count
DLLLOCAL bool | is_unique () const
| returns true if the reference count is 1
DLLEXPORT void | ROreference () const
| atomically increments the reference count
DLLEXPORT bool | ROdereference () const
| atomically decrements the reference count

## Static Public Member Functions

static DLLLOCAL const char * | getStaticTypeName ()
| returns the type name (useful in templates)
static DLLLOCAL qore_type_t | getStaticTypeCode ()
| returns the type code (useful in templates)
static DLLLOCAL bool | getValue (QoreBoolNode *v)
| returns the value of the argument (useful in templates)

## Protected Member Functions

DLLLOCAL | QoreBoolNode (bool n_b)
| the constructor can only be called by a subclass

## Protected Attributes

bool | b
| boolean value for the object

## Detailed Description

base class for Qore's 2 boolean classes: QoreBoolTrueNode and QoreBoolFalseNode

Note
  this class cannot be instantiated; use get_bool_node() to get a pointer to an object of a subclass

## Member Function Documentation

virtual DLLEXPORT int QoreBoolNode::getAsString | ( | QoreString & | str,
|  | int | foff,
|  | class ExceptionSink * | xsink
| ) |  | const

virtual

concatenate the verbose string representation of the value (including all contained values for container types) to an existing QoreString

used for n and N printf formatting

Parameters

  str | the string representation of the type will be concatenated to this QoreString reference
  foff | for multi-line formatting offset, -1 = no line breaks
  xsink | if an error occurs, the Qore-language exception information will be added here

Returns
  -1 for exception raised, 0 = OK

Implements AbstractQoreNode.

virtual DLLEXPORT QoreString* QoreBoolNode::getAsString | ( | bool & | del,
|  | int | foff,
|  | class ExceptionSink * | xsink
| ) |  | const

virtual

returns a QoreString giving the verbose string representation of the value (including all contained values for container types)

Used for n and N printf formatting. Do not call this function directly; use the QoreNodeAsStringHelper class (defined in QoreStringNode.h) instead

Parameters

  del | if this is true when the function returns, then the returned QoreString pointer should be deleted, if false, then it must not be
  foff | for multi-line formatting offset, -1 = no line breaks
  xsink | if an error occurs, the Qore-language exception information will be added here

See Also
  QoreNodeAsStringHelper

Implements AbstractQoreNode.

virtual DLLEXPORT DateTime* QoreBoolNode::getDateTimeRepresentation | ( | bool & | del | ) | const

virtual

returns the DateTime representation of this type (default implementation: returns ZeroDate, del = false)

NOTE: Use the DateTimeValueHelper class instead of using this function directly

Parameters

  del | output parameter: if del is true, then the returned DateTime pointer belongs to the caller (and must be deleted manually), if false, then it must not be

See Also
  DateTimeValueHelper

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT void QoreBoolNode::getDateTimeRepresentation | ( | DateTime & | dt | ) | const

virtual

assigns the date representation of a value to the DateTime reference passed, default implementation does nothing

Parameters

  dt | the DateTime reference to be assigned

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT QoreString* QoreBoolNode::getStringRepresentation | ( | bool & | del | ) | const

virtual

returns the value of the type converted to a string, default implementation: returns the empty string

NOTE: do not use this function directly, use QoreStringValueHelper instead

Parameters

  del | output parameter: if del is true, then the resulting QoreString pointer belongs to the caller (and must be deleted manually), if false it must not be

Returns
  a QoreString pointer, use the del output parameter to determine ownership of the pointer

See Also
  QoreStringValueHelper

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT void QoreBoolNode::getStringRepresentation | ( | QoreString & | str | ) | const

virtual

concatentates the value of the type to an existing QoreString reference, default implementation does nothing

Parameters

  str | a reference to a QoreString where the value of the type will be concatenated

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT const char* QoreBoolNode::getTypeName | ( |  | ) | const

virtual

returns the type name as a c string

Returns
  the type name as a c string

Implements AbstractQoreNode.

virtual DLLEXPORT bool QoreBoolNode::is_equal_hard | ( | const AbstractQoreNode * | v,
|  | ExceptionSink * | xsink
| ) |  | const

virtual

tests for equality ("deep compare" including all contained values for container types) without type conversions (hard compare)

Parameters

  v | the value to compare
  xsink | if an error occurs, the Qore-language exception information will be added here

Returns
  true if the objects are equal, false if not

Implements AbstractQoreNode.

virtual DLLEXPORT bool QoreBoolNode::is_equal_soft | ( | const AbstractQoreNode * | v,
|  | ExceptionSink * | xsink
| ) |  | const

virtual

tests for equality ("deep compare" including all contained values for container types) with possible type conversion (soft compare)

Parameters

  v | the value to compare
  xsink | if an error occurs, the Qore-language exception information will be added here

Returns
  true if the objects are equal, false if not

Implements AbstractQoreNode.

The documentation for this class was generated from the following file:

- include/qore/QoreBoolNode.h (5431)